proc import datafile="R:\teaching\short course\missing data\session5\simulation study\dat_mp.csv" 
out=dat_mp dbms=csv replace; 
getnames=yes; 
run;

proc contents data=dat_mp;
run;

data dat_mp2;
set dat_mp;
if r1=0 then y1_m=.;
else y1_m=y1;
if r2=0 then y2_m=.;
else y2_m=y2;
if r3=0 then y3_m=.;
else y3_m=y3;
if r4=0 then y4_m=.;
else y4_m=y4;
run;

/*Examine missing pattern*/
proc mi nimpute=0 data=dat_mp2 out=out_mi;
var x y1_m y2_m y3_m y4_m;
run;

/*MLE by EM*/
proc mi data=dat_mp2 seed=1518971 simple nimpute=0;
      em itprint outem=outem;
      var x y1_m y2_m y3_m y4_m;
   run;

/*SMICE*/

/*Create new data file with identical study variables*/
data dat_mp3;
set dat_mp2;
y1_I=y1_m;
y2_I=y2_m;
y3_I=y3_m;
y4_I=y4_m;
run;

proc mi data=dat_mp3 seed=94791 nimpute=5 /*round=*/ /*minimum=*/ /*maximum=*/ out=out_mi;
class y4_I;
/*by;*/
fcs reg(y1_I=x y2_I y3_I y4_I);
fcs regpredmeanmatch(y2_I=x y1_I y3_I y4_I);
fcs reg(y3_I=x y1_I y2_I y4_I);
fcs logistic(y4_I=x y1_I y2_I y3_I);
var x y1_I y2_I y3_I y4_I;
run;

/*Inference*/

/*GLM*/
proc genmod data=out_mi;
       model y3_I= x y1_I y2_I/covb;
       by _Imputation_;
       ods output ParameterEstimates=gmparms
                  ParmInfo=gmpinfo
                  CovB=gmcovb;
run;

proc mianalyze parms=gmparms covb=gmcovb parminfo=gmpinfo;
      modeleffects Intercept x y1_I y2_I;
run;

/*Logistic model*/
proc logistic data=out_mi;
      class y4_I;
      model y4_I= x y1_I y2_I y3_I/ covb;
      by _Imputation_;
      ods output ParameterEstimates=lgsparms
                 CovB=lgscovb;
run;

proc mianalyze parms=lgsparms
                  covb(effectvar=stacking)=lgscovb;
      modeleffects Intercept x y1_I y2_I y3_I;
run;

/*
proc mi <options>;
by variables;
class variables;/*for categorical variables*/
EM <options>; /*EM approach*/
FREQ variable; /*# of representation*/
MCMC <options>; /*MCMC approach*/
MONOTONE <options>; /*Approach for MONOTONE missingness*/
FCS <options>; /*SMICE*/
TRANSFORM log(X); /*Transform variables before imputation*/
var variables; /*variables involved in imputation procedure*/
run;
*/
